

%Reads result files and plots them


filename = '/home/shomea/m/mlnorhei/Desktop/MasterThesis/MRST_Sintef/mrst-2018a/mrst-2018a/MyTries/ExperimentalResults/Simple/simple_n=100_h=1_nt=2_AMG.txt'; %husk at ":" er bytta med "-"
filenameMLdivide = '/home/shomea/m/mlnorhei/Desktop/MasterThesis/MRST_Sintef/mrst-2018a/mrst-2018a/MyTries/ExperimentalResults/mldivide.txt';


amg=true;
    %------------------
    %Ikke endre disse!
    olympus = false;
    spe10 = false;
    hybrid = false;
    simple =false;
    %------------------

    MLdivide = true;

    layerstart = '';
    layerstop = '';
    bindestrek = false;

    plus = 0;

     if filename(108+plus)=='O'
         olympus = true;
     elseif filename(108+plus)=='S'
         if filename(109+plus)=='i'
            simple=true;
         else
            spe10 = true;
         end
     elseif filename(108+plus)=='H'
         hybrid = true;
     end

    if spe10
        for i=(121+plus):(125+plus)
            if double(filename(i))>47 && double(filename(i))<58 && bindestrek == false
                layerstart = strcat(layerstart,filename(i));
            elseif double(filename(i))>47 && double(filename(i))<58 && bindestrek == true
                layerstop = strcat(layerstop,filename(i));
            elseif double(filename(i)) == 45
                bindestrek = true;
            end
        end
        if bindestrek == true
            layerstring = strcat(layerstart,':',layerstop);
        else
            layerstring = layerstart;
        end
    elseif hybrid
        for i=(128+plus):(132+plus)
            if double(filename(i))>47 && double(filename(i))<58 && bindestrek == false
                layerstart = strcat(layerstart,filename(i));
            elseif double(filename(i))>47 && double(filename(i))<58 && bindestrek == true
                layerstop = strcat(layerstop,filename(i));
            elseif double(filename(i)) == 45
                bindestrek = true;
            end
        end
        if bindestrek == true
            layerstring = strcat(layerstart,':',layerstop);
        else
            layerstring = layerstart;
        end
    elseif olympus
        caseNo = '';
        for i=(124+plus):(125+plus)
            if double(filename(i))>47 && double(filename(i))<58
                caseNo = strcat(caseNo,filename(i));
            end
        end
    elseif simple
        nstring = '';
        for i=(124+plus):(126+plus)
            if double(filename(i))>47 && double(filename(i))<58 
                nstring = strcat(nstring,filename(i));
            end
        end
        n=str2double(nstring);
    end


    fileID = fopen(filename,'r');
    fileIDmldivide = fopen(filenameMLdivide,'r');

    resultsIter = zeros(7,4,8);
    resultsTime = zeros(7,4,8);
    fgetl(fileID);
    fgetl(fileIDmldivide);
    fgetl(fileIDmldivide);

    %preconditioners = {'amg','relaxation'};

    solvers = {'bicgstab', ... % Biconjugate gradient stabilized method
                   'cg', ... % Conjugate gradient
                   'bicgstabl', ... % Bicgstab variant
                   'gmres', ... % Generalized minimal residual method
                   'lgmres', ... % GMRES variant
                   'fgmres', ... % Flexible-GMRES 
                   'idrs'}; % Induced Dimension Reduction method IDR(s)

    coarsenings = {'ruge_stuben', ... % Ruge-stuben coarsening ("standard" coarsening)
                          'smoothed_aggregation', ... % Aggregation with smoothed iterates
                          'aggregation', ... % Aggregation - very fast coarsening due to very simple constant interpolation
                          'smoothed_aggr_emin'};

    smoothers = {'spai0', ... % Sparse approximate inverse, degree 0
                               'spai1', ... % Sparse approximate inverse
                               'gauss_seidel', ... % Gauss-seidel
                               'ilu0', ... % Incomplete LU-factorization without fill-in
                               'iluk', ... % Level-based ILU
                               'ilut', ... % Thresholded ILU
                               'damped_jacobi', ... % Damped Jacobi
                               'chebyshev'}; % Chebyshev smoothing

    

    while ~feof(fileID)
        line = fgetl(fileID);
        preconditioner = '';
        for i=2:11
            if 96 < double(line(i)) && double(line(i)) < 123
                preconditioner = strcat(preconditioner,line(i));
            end
        end
        solver = '';
        for i=13:22
            if 96 < double(line(i)) && double(line(i)) < 123 
                solver = strcat(solver,line(i));
            end
        end
        coarsening = '';
        for i=24:49
            if (96 < double(line(i)) && double(line(i)) < 123) || double(line(i))==95
                coarsening = strcat(coarsening,line(i));
            end
        end
        smoother = '';
        for i=51:63
            if (96 < double(line(i)) && double(line(i)) < 123) || double(line(i))==95 || (47 < double(line(i)) && double(line(i)) < 58)
                smoother = strcat(smoother,line(i));
            end
        end

        if ~isempty(preconditioner)
            for i=1:2
                if strcmp(preconditioners{i},preconditioner)
                    precondIndex = i;
                end
            end

            for i=1:7
                if strcmp(solvers{i},solver)
                    solverIndex = i;
                end
            end

            for i=1:4
                if strcmp(coarsenings{i},coarsening)
                    coarsenIndex = i;
                end
            end
            for i=1:8
                if strcmp(smoothers{i},smoother)
                    smootherIndex = i;
                end
            end
            iterations = '';
            for i=65:74
                if double(line(i))>47 && double(line(i))<58
                    iterations = strcat(iterations,line(i));
                end

            end
            iterations = str2double(iterations);
            time = '';
            for i=76:87
                if double(line(i)) == 46 || (double(line(i))>47 && double(line(i))<58)
                    time = strcat(time,line(i));
                end
            end
            time = str2double(time);
            resultsIter(solverIndex,coarsenIndex,smootherIndex) = iterations;
            resultsTime(solverIndex,coarsenIndex,smootherIndex) = time;
        end
    end
fclose(fileID);



for q=1:2 % one plot for iterations, and one for time

    figure(q)
    hold on
    if amg == true
        precond = 'AMG';
    else
        precond = 'relaxation';
    end
    if olympus
        title(['Olympus: case no.' caseNo ', with ' precond ' as preconditioner'])
    elseif spe10
        if isempty(layerstop)
            title(['Layer ' layerstart ' of SPE10 with ' precond ' as preconditioner'])
        else
            layerstring = strcat(layerstart,':',layerstop);
            title(['Layer ' layerstring ' of SPE10 with ' precond ' as preconditioner'])
        end
    elseif hybrid
        if isempty(layerstop)
            title(['Layer ' layerstart ' of hybrid with ' precond ' as preconditioner'])
        else
            layerstring = strcat(num2str(layerstart),':',layerstop);
            title(['Layer ' layerstring ' of hybrid with ' precond ' as preconditioner'])
        end
    elseif simple
        title(['Simple: dimensions ' nstring 'x' nstring ', with ' precond ' as preconditioner'])
    end
    for i=1:7
        for j=1:4
            if i == 1
                color = [255/255,165/255,0];
            elseif i == 2
                color = [124/255,252/255,0];
            elseif i == 3
                color = [1,0,0];
            elseif i == 4 
                color = [0,191/255,1];
            elseif i == 5
                color = [218/255,112/255,214/255];
            elseif i == 6
                color = [0,0,205/255];
            elseif i == 7
                color = [160/255,82/255,45/255];
            end
            if j == 1 
                marker = '-';
            elseif j == 2
                marker = '--';
            elseif j == 3
                marker = '-.'; % was :
            else 
                marker = ':';  % was -.
            end
            if q==1
                plot(1:8,log(reshape(resultsIter(i,j,:),1,8)),marker,'color',color,'MarkerSize',7)
            else
                plot(1:8,log(reshape(resultsTime(i,j,:),1,8)),marker,'color',color,'MarkerSize',7)
            end
        end
    end
    if(q==2)
        t_dir = ones(8)*1.448200e-02;
        plot(1:8,log(t_dir),'color','k','LineWidth',2)
    end
    xlabel('Smoothers')
    if q == 1
        ylabel('ln(# iterations)')
    else
        ylabel('ln(time)')
    end
    if q==1
        xlim([0.7 11]);
        h = zeros(11, 1);
        h(1) = plot(NaN,NaN,'-k');
        h(2) = plot(NaN,NaN,'--k');
        h(3) = plot(NaN,NaN,'-.k');
        h(4) = plot(NaN,NaN,':k');
        h(5) = plot(NaN,NaN,'color',[255/255,165/255,0]);
        h(6) = plot(NaN,NaN,'color',[124/255,252/255,0]);
        h(7) = plot(NaN,NaN,'color',[1,0,0]);
        h(8) = plot(NaN,NaN,'color',[0,191/255,1]);
        h(9) = plot(NaN,NaN,'color',[218/255,112/255,214/255]);
        h(10) = plot(NaN,NaN,'color',[0,0,205/255]);
        h(11) = plot(NaN,NaN,'color',[160/255,82/255,45/255]);

        legend(h, 'Ruge-Stuben','Smooth. aggr.','Aggregation','Sm. aggr. emin.','BiCGstab','CG','BiCGstabl','GMRES','LGMRES', 'FGMRES','IDR(s)')
    else
        xlim([0.7 11]);
        h = zeros(12, 1);
        h(1) = plot(NaN,NaN,'-k');
        h(2) = plot(NaN,NaN,'--k');
        h(3) = plot(NaN,NaN,'-.k');
        h(4) = plot(NaN,NaN,':k');
        h(5) = plot(NaN,NaN,'color',[255/255,165/255,0]);
        h(6) = plot(NaN,NaN,'color',[124/255,252/255,0]);
        h(7) = plot(NaN,NaN,'color',[1,0,0]);
        h(8) = plot(NaN,NaN,'color',[0,191/255,1]);
        h(9) = plot(NaN,NaN,'color',[218/255,112/255,214/255]);
        h(10) = plot(NaN,NaN,'color',[0,0,205/255]);
        h(11) = plot(NaN,NaN,'color',[160/255,82/255,45/255]);
        h(12) = plot(NaN,NaN,'color','k','LineWidth',2);

        legend(h, 'Ruge-Stuben','Smooth. aggr.','Aggregation','Sm. aggr. emin.','BiCGstab','CG','BiCGstabl','GMRES','LGMRES','FGMRES','IDR(s)','mldivide')
    end
        
    names = {'SPAI0'; 'SPAI1'; 'G-S'; 'ILU0'; 'ILU(k)'; 'ILUT'; 'D.Jac.'; 'Cheb.'};
    set(gca,'xtick',1:8,'xticklabel',names);
end
