
%Program that reads three result files, and plots mean values with standard
%deviation

filename1 = '/home/shomea/m/mlnorhei/Desktop/MasterThesis/MRST_Sintef/mrst-2018a/mrst-2018a/MyTries/ExperimentalResults/SPE10/layers=1-35_nt=2_relaxation.txt'; %husk at ":" er bytta med "-"
filename2 = '/home/shomea/m/mlnorhei/Desktop/MasterThesis/MRST_Sintef/mrst-2018a/mrst-2018a/MyTries/ExperimentalResults/SPE10/layers=1-35_nt=2_relaxation2.txt'; %husk at ":" er bytta med "-"
filename3 = '/home/shomea/m/mlnorhei/Desktop/MasterThesis/MRST_Sintef/mrst-2018a/mrst-2018a/MyTries/ExperimentalResults/SPE10/layers=1-35_nt=2_relaxation3.txt'; %husk at ":" er bytta med "-"

filenameMLdivide = '/home/shomea/m/mlnorhei/Desktop/MasterThesis/MRST_Sintef/mrst-2018a/mrst-2018a/MyTries/ExperimentalResults/mldivide.txt';

combos = {[1,1,4],[1,1,5],[2,1,4],[2,1,5],[3,1,4],[3,1,5],[7,1,4],[7,1,5]};

amg = false;

num = 3;
for N = 1:num
    if N == 1 
        filename = filename1;
    elseif N == 2 
        filename = filename2;
    elseif N == 3
        filename = filename3;
    end
    %------------------
    %Ikke endre disse!
    olympus = false;
    spe10 = false;
    hybrid = false;
    simple =false;
    %------------------

    MLdivide = true;

    layerstart = '';
    layerstop = '';
    bindestrek = false;

    plus = 0;

     if filename(108+plus)=='O'
         olympus = true;
     elseif filename(108+plus)=='S'
         if filename(109+plus)=='i'
            simple=true;
         else
            spe10 = true;
         end
     elseif filename(108+plus)=='H'
         hybrid = true;
     end

    if spe10
        for i=(121+plus):(125+plus)
            if double(filename(i))>47 && double(filename(i))<58 && bindestrek == false
                layerstart = strcat(layerstart,filename(i));
            elseif double(filename(i))>47 && double(filename(i))<58 && bindestrek == true
                layerstop = strcat(layerstop,filename(i));
            elseif double(filename(i)) == 45
                bindestrek = true;
            end
        end
        if bindestrek == true
            layerstring = strcat(layerstart,':',layerstop);
        else
            layerstring = layerstart;
        end
    elseif hybrid
        for i=(128+plus):(132+plus)
            if double(filename(i))>47 && double(filename(i))<58 && bindestrek == false
                layerstart = strcat(layerstart,filename(i));
            elseif double(filename(i))>47 && double(filename(i))<58 && bindestrek == true
                layerstop = strcat(layerstop,filename(i));
            elseif double(filename(i)) == 45
                bindestrek = true;
            end
        end
        if bindestrek == true
            layerstring = strcat(layerstart,':',layerstop);
        else
            layerstring = layerstart;
        end
    elseif olympus
        caseNo = '';
        for i=(124+plus):(125+plus)
            if double(filename(i))>47 && double(filename(i))<58
                caseNo = strcat(caseNo,filename(i));
            end
        end
    elseif simple
        nstring = '';
        for i=(124+plus):(126+plus)
            if double(filename(i))>47 && double(filename(i))<58 
                nstring = strcat(nstring,filename(i));
            end
        end
        n=str2double(nstring);
    end


    fileID = fopen(filename,'r');
    fileIDmldivide = fopen(filenameMLdivide,'r');

    resultsIter = zeros(7,4,8);
    resultsTime = zeros(7,4,8);
    fgetl(fileID);
    fgetl(fileIDmldivide);
    fgetl(fileIDmldivide);

    %preconditioners = {'amg','relaxation'};

    solvers = {'bicgstab', ... % Biconjugate gradient stabilized method
                   'cg', ... % Conjugate gradient
                   'bicgstabl', ... % Bicgstab variant
                   'gmres', ... % Generalized minimal residual method
                   'lgmres', ... % GMRES variant
                   'fgmres', ... % Flexible-GMRES 
                   'idrs'}; % Induced Dimension Reduction method IDR(s)

    coarsenings = {'ruge_stuben', ... % Ruge-stuben coarsening ("standard" coarsening)
                          'smoothed_aggregation', ... % Aggregation with smoothed iterates
                          'aggregation', ... % Aggregation - very fast coarsening due to very simple constant interpolation
                          'smoothed_aggr_emin'};

    smoothers = {'spai0', ... % Sparse approximate inverse, degree 0
                               'spai1', ... % Sparse approximate inverse
                               'gauss_seidel', ... % Gauss-seidel
                               'ilu0', ... % Incomplete LU-factorization without fill-in
                               'iluk', ... % Level-based ILU
                               'ilut', ... % Thresholded ILU
                               'damped_jacobi', ... % Damped Jacobi
                               'chebyshev'}; % Chebyshev smoothing



    while ~feof(fileID)
        line = fgetl(fileID);
        preconditioner = '';
        for i=2:11
            if 96 < double(line(i)) && double(line(i)) < 123
                preconditioner = strcat(preconditioner,line(i));
            end
        end
        solver = '';
        for i=13:22
            if 96 < double(line(i)) && double(line(i)) < 123 
                solver = strcat(solver,line(i));
            end
        end
        coarsening = '';
        for i=24:49
            if (96 < double(line(i)) && double(line(i)) < 123) || double(line(i))==95
                coarsening = strcat(coarsening,line(i));
            end
        end
        smoother = '';
        for i=51:63
            if (96 < double(line(i)) && double(line(i)) < 123) || double(line(i))==95 || (47 < double(line(i)) && double(line(i)) < 58)
                smoother = strcat(smoother,line(i));
            end
        end

        if ~isempty(preconditioner)
            for i=1:2
                if strcmp(preconditioners{i},preconditioner)
                    precondIndex = i;
                end
            end

            for i=1:7
                if strcmp(solvers{i},solver)
                    solverIndex = i;
                end
            end

            for i=1:4
                if strcmp(coarsenings{i},coarsening)
                    coarsenIndex = i;
                end
            end
            for i=1:8
                if strcmp(smoothers{i},smoother)
                    smootherIndex = i;
                end
            end
            iterations = '';
            for i=65:74
                if double(line(i))>47 && double(line(i))<58
                    iterations = strcat(iterations,line(i));
                end

            end
            iterations = str2double(iterations);
            time = '';
            for i=76:87
                if double(line(i)) == 46 || (double(line(i))>47 && double(line(i))<58)
                    time = strcat(time,line(i));
                end
            end
            time = str2double(time);
            resultsIter(solverIndex,coarsenIndex,smootherIndex) = iterations;
            resultsTime(solverIndex,coarsenIndex,smootherIndex) = time;
        end
    end
    if N == 1 
        resultsIter1 = resultsIter;
        resultsTime1 = resultsTime;
    elseif N == 2 
        resultsIter2 = resultsIter;
        resultsTime2 = resultsTime;
    elseif N == 3 
        resultsIter3 = resultsIter;
        resultsTime3 = resultsTime;
    end
        
    fclose(fileID);
    
end

n_comb = length(combos);
x_comb = 1:n_comb;

meanValueIter = (resultsIter1+resultsIter2+resultsIter3)./3;
meanValueTime = (resultsTime1+resultsTime2+resultsTime3)./3;

standDevIter = ( ( (resultsIter1-meanValueIter).^2 + (resultsIter2-meanValueIter).^2 + (resultsIter3-meanValueIter).^2) ./3 ).^(1/2);
standDevTime = ( ( (resultsTime1-meanValueTime).^2 + (resultsTime2-meanValueTime).^2 + (resultsTime3-meanValueTime).^2) ./3 ).^(1/2);

for q=1:2 % one plot for iterations, and one for time
    figure(q)
    hold on
    if amg == true
        precond = 'AMG';
    else
        precond = 'relaxation';
    end
    if olympus
        title(['Olympus: case no.' caseNo ', with ' precond ' as preconditioner'])
    elseif spe10
        if isempty(layerstop)
            title(['Layer ' layerstart ' of SPE10 with ' precond ' as preconditioner'])
        else
            layerstring = strcat(layerstart,':',layerstop);
            title(['Layer ' layerstring ' of SPE10 with ' precond ' as preconditioner'])
        end
    elseif hybrid
        if isempty(layerstop)
            title(['Layer ' layerstart ' of hybrid with ' precond ' as preconditioner'])
        else
            layerstring = strcat(num2str(layerstart),':',layerstop);
            title(['Layer ' layerstring ' of hybrid with ' precond ' as preconditioner'])
        end
    elseif simple
        title(['Simple: dimensions ' nstring 'x' nstring ', with ' precond ' as preconditioner'])
    end
    xlabel('Combinations')
    if q == 1
        ylabel('# iterations')
    else
        ylabel('time (s)')
    end
    m=1;
    for i=1:7
        for j=1:4
            if i == 1
                color = [255/255,165/255,0];
            elseif i == 2
                color = [124/255,252/255,0];
            elseif i == 3
                color = [1,0,0];
            elseif i == 4 
                color = [0,191/255,1];
            elseif i == 5
                color = [218/255,112/255,214/255];
            elseif i == 6
                color = [0,0,205/255];
            elseif i == 7
                color = [160/255,82/255,45/255];
            end

            marker = 'o';
            xticks(x_comb)
            if q==1
                for k = 1:8
                    if any(cellfun(@isequal,combos,repmat({[i,j,k]},size(combos))))
                        errorbar(m,meanValueIter(i,j,k),standDevIter(i,j,k),marker,'color',color,'MarkerSize',7)
                        m = m+1;
                    end
                end
            else
                for k = 1:8
                    if any(cellfun(@isequal,combos,repmat({[i,j,k]},size(combos))))
                        errorbar(m,meanValueTime(i,j,k),standDevTime(i,j,k),marker,'color',color,'MarkerSize',7)
                        m = m+1;
                    end
                    
                end
            end
        end
    end

end
